#ifndef __INC_POS_PEXEC_RAWDOFMT_H
#define __INC_POS_PEXEC_RAWDOFMT_H
/*******************************************************************
 Includes Release 24
 (C) Copyright 1995-1997 proDAD
     All Rights Reserved

 $AUT Holger Burkarth
 $DAT >>RawDoFmt.h<<   27 Feb 1997    14:07:28 - (C) ProDAD
*******************************************************************/
#ifndef __INC_POS_PEXEC_TYPES_H
#include <pExec/Types.h>
#endif


/*----------------------------------
-----------------------------------*/
struct pOS_RawDoFmtData
{
  const CHAR  *rdft_Format;
  const ULONG *rdft_Argv;

/*** Internal ***/
  VOID      (*rdft_InterFmt)(_R_A0 struct pOS_RawDoFmtData*); /* default=NULL  */
  UWORD       rdft_Width;    /* default=0 */
  UWORD       rdft_Limit;    /* default=UWORD_MAX */
  UBYTE       rdft_Flags;    /* (enum pOS_RawDoFmtFlags) */
  UBYTE       rdft_Data;     /* Output-Data for call rdft_DoFmt() */

/*** External ***/
  VOID      (*rdft_DoFmt)(_R_A0 struct pOS_RawDoFmtData*);
  ULONG       rdft_ResSize;  /*  */
  ULONG       rdft_User[2];  /* Free for use */

  UBYTE       rdft_Reserved[8];
};


enum pOS_RawDoFmtFlags /** rdft_Flags **/
{
  RDFTF_None=0,
  RDFTF_JustLeft        =0x01,  /* (-) left justification */
  RDFTF_Long            =0x02,  /* (l) data is longword */
  RDFTF_Field           =0x04,  /* (.)                  */
  RDFTF_Fill0           =0x08,  /* (0)                  */

  RDFTF_UseNullPtr      =0x80,  /* Null-Pointer by %s => "" */
};





#endif
