#ifndef __INC_POS_PEXEC_RESIDENT_H
#define __INC_POS_PEXEC_RESIDENT_H
/*******************************************************************
 Includes Release 24
 (C) Copyright 1995-1997 proDAD
     All Rights Reserved

 $AUT Holger Burkarth
 $DAT >>Resident.h<<   12 Sep 1996    10:17:07 - (C) ProDAD
*******************************************************************/
#ifndef __INC_POS_PEXEC_TYPES_H
#include <pExec/Types.h>
#endif


/*----------------------------------
-----------------------------------*/
struct pOS_Resident
{
  UWORD               rt_MatchWord;   /* word to match on  */
  const struct pOS_Resident *rt_MatchTag; /* pointer to the above */
  APTR                rt_EndSkip;     /* address to continue scan */
  ULONG               rt_Flags;       /* various tag flags */
  UWORD               rt_Version;     /* release version number */
  UWORD               rt_Revision;    /* */
  UBYTE               rt_Type;        /* type of module (NTYP_XXXXXX) */
  SBYTE               rt_Pri;         /* initialization priority */
  const CHAR         *rt_Name;        /* pointer to node name */
  const CHAR         *rt_IdString;    /* pointer to identification string */
  APTR                rt_Init;        /* pointer to init code or (const pOS_ResidentLibInit*) */
  const struct pOS_TagItem  *rt_Describe;
};




#define RTC_MATCHWORD 0x4AFC

enum pOS_ResidentFlags
{
 RTF_COLDSTART =0x01,
 RTF_SINGLETASK=0x02,
 RTF_AFTERDOS  =0x04,
 RTF_AUTOINIT  =0x80, /* rt_Init points to data structure */
};


#endif
