#ifndef __INC_POS_PEXEC_TSTTAGS_H
#define __INC_POS_PEXEC_TSTTAGS_H
/*******************************************************************
 Includes Release 24
 (C) Copyright 1995-1997 proDAD
     All Rights Reserved

 $AUT Holger Burkarth
 $DAT >>TstTags.h<<   05 Mar 1997    10:00:05 - (C) ProDAD
*******************************************************************/
#ifndef __INC_POS_PUTIL_TAGITEM_H
#include <pUtil/TagItem.h>
#endif

enum pOS_ExecTestTags
{
  EXTSTTAG_First = TAG_USER + 0x110000,

  EXTSTTAG_CPU,         /* (ULONG) CPU-ID (enum pOS_ExecCPUType) */
  EXTSTTAG_GetCPU,      /* (ULONG*)       (enum pOS_ExecCPUType) */
  EXTSTTAG_FPU,         /* (ULONG) FPU-ID    */
  EXTSTTAG_GetFPU,      /* (ULONG*)          */
  EXTSTTAG_MainOSID,    /* (ULONG)           */
  EXTSTTAG_GetDTT,      /* (const CHAR**)    */


/*\
*** Example:
***
*** if(pOS_ExecCheck(EXTSTTAG_FPU,TRUE,TAG_END)) => FPU exists
*** else                                         => no FPU exists
***
*** or
***
*** ULONG FPUID;
*** pOS_ExecCheck(EXTSTTAG_GetFPU,(ULONG)&FPUID,TAG_END);
***
*** if(FPUID != 0) FPU exists
\*/






};





enum pOS_ExecCPUType
{
  EXCPUTYP_Mask    = 0x7fff0000,
  EXCPUTYP_SubMask = 0x0000f000,


/** 68k **/

  EXCPUTYP_68k     = 0x00010000,
  EXCPUTYP_68010,
  EXCPUTYP_68020,
  EXCPUTYP_68030,
  EXCPUTYP_68040,
  EXCPUTYP_68kSkip,
  EXCPUTYP_68060,

};






#endif
